-- Tests for hom4ps.cpkg
Package $apcocoa/ts/hom4ps


Define Initialize()
EndDefine;

Define ExcludeTestsOn()
  Return [["*", "MacOSX"]];
EndDefine; -- ExcludeTestsOn

-- solve a polynomial system over RR
Define TestHom4ps01()

TestRing::=QQ[x[1..2]];

Using TestRing Do
   P := [3x[1]x[2] + x[2] - 1, x[1]x[2] - x[1], x[1]^2 - x[1], x[2]^2 - x[2]];

   FullResult:=Hom.LRSolve(P,1);
  	
   Result:=[];
   For I:=1 To Len(FullResult) Do 
    Result1:=[];
    For J:=1 To Len(FullResult[I]) Do 
		Temp:=FullResult[I][J]; Temp1:=FullResult[I][J]; 
		If Temp[2] =0  Then Append(Result1,Temp1[1]); EndIf;
	EndFor;
	If Len(Result1)=Len(FullResult[1]) Then Append(Result,Result1); EndIf;
   EndFor;

  Expected:=[[0, 1]];
  For I:=1 To Len(Result) Do
   	For J:=1 To Len(Result[I]) Do
  		$apcocoa/ts/assert.AssertEqualsNumericalNumber(Result[I][J], Expected[I][J],0.0001 ,"TestHom4ps01 Failed!");
  	EndFor;
  EndFor;
EndUsing;

EndDefine;


Define TestHom4ps02()

TestRing::=QQ[x[1..3]];

Using TestRing Do
   P := [2x[1]x[2]x[3] + x[1]x[2] + x[2]x[3] - x[2], 6x[1]x[2]x[3] - 3x[1]x[2] - 3x[1]x[3] - 3x[1] + 3, 3x[1]x[2] + x[1] - 1, x[1]^2 - x[1], x[2]^2 - x[2], x[3]^2 - x[3]];

   FullResult:=Hom.LRSolve(P,1);
  	
   Result:=[];
   For I:=1 To Len(FullResult) Do 
    Result1:=[];
    For J:=1 To Len(FullResult[I]) Do 
		Temp1:=FullResult[I][J]; Temp2:=FullResult[I][J]; 
		If Temp1[2] =0  Then Append(Result1,Temp2[1]); EndIf;
	EndFor;
	If Len(Result1)=Len(FullResult[1]) Then Append(Result,Result1); EndIf;
   EndFor;

  Expected:=[[5000000000000001/5000000000000000, 0, 0]];
  For I:=1 To Len(Result) Do
   	For J:=1 To Len(Result[I]) Do
  		$apcocoa/ts/assert.AssertEqualsNumericalNumber(Result[I][J], Expected[I][J],0.0001 ,"TestHom4ps02 Failed!");
  	EndFor;
  EndFor;
EndUsing;

EndDefine;

EndPackage;
