--Tests for pgbc.cpkg
Package $apcocoa/ts/pgbc

Define Initialize()

EndDefine;


Define ExcludeTestsOn()
  -- Exlude all tests on MacOSX and TestTemplate01 on Windows.
  Return [["*", "MacOSX"]];
EndDefine; -- ExcludeTestsOn


Define TestPGBC01()

TestRing::=ZZ/(32003)[x,y,z];

Using TestRing Do

	F1:=x^2y+zy;
	F2:=x^2yz+y^2;
	F3:=z^4+z^2y;
	F:=[F1,F2,F3];
	Expected:=[z^4 + yz^2, x^2y + yz, yz^2 - y^2, y^3];
	Result:=$apcocoa/pgbc.ParallelGBC(F,2);
	$apcocoa/ts/assert.AssertEqualsExact(Result,Expected, "Wrong result for TestPGBC01.");
	
EndUsing;

EndDefine; -- TestPGBC01

Define TestPGBC02()

TestRing::=ZZ/(32003)[x[1..9],h];

Using TestRing Do

	F:=[x[1]^2 + 2*x[2]^2 + 2*x[3]^2 + 2*x[4]^2 + 2*x[5]^2 + 2*x[6]^2 + 2*x[7]^2 + 2*x[8]^2 + 2*x[9]^2 - x[1]*h,
		2*x[1]*x[2] + 2*x[2]*x[3] + 2*x[3]*x[4] + 2*x[4]*x[5] + 2*x[5]*x[6] + 2*x[6]*x[7] + 2*x[7]*x[8] + 2*x[8]*x[9]- x[2]*h,
		x[2]^2 + 2*x[1]*x[3] + 2*x[2]*x[4] + 2*x[3]*x[5] + 2*x[4]*x[6] + 2*x[5]*x[7] + 2*x[6]*x[8] + 2*x[7]*x[9] - x[3]*h,
		2*x[2]*x[3] + 2*x[1]*x[4] + 2*x[2]*x[5] + 2*x[3]*x[6] + 2*x[4]*x[7] + 2*x[5]*x[8] + 2*x[6]*x[9] - x[4]*h,
		x[3]^2 + 2*x[2]*x[4] + 2*x[1]*x[5] + 2*x[2]*x[6] + 2*x[3]*x[7] + 2*x[4]*x[8] + 2*x[5]*x[9] - x[5]*h,
		2*x[3]*x[4] + 2*x[2]*x[5] + 2*x[1]*x[6] + 2*x[2]*x[7] + 2*x[3]*x[8] + 2*x[4]*x[9] -x[6]*h,
		x[4]^2 + 2*x[3]*x[5] + 2*x[2]*x[6] + 2*x[1]*x[7] + 2*x[2]*x[8] + 2*x[3]*x[9] - x[7]*h,
		2*x[4]*x[5] + 2*x[3]*x[6] + 2*x[2]*x[7] + 2*x[1]*x[8] + 2*x[2]*x[9] - x[8]*h,
		x[1] + 2*x[2] + 2*x[3] + 2*x[4] + 2*x[5] + 2*x[6] + 2*x[7] + 2*x[8] + 2*x[9] - h
	];
	Expected:=143;
	Result:=Len($apcocoa/pgbc.ParallelGBC(F,2)); // the GB itself is very large for a testcase (500+KB)..
	$apcocoa/ts/assert.AssertEqualsExact(Result,Expected, "Wrong result for TestPGBC02.");
EndUsing;

EndDefine; -- TestPGBC02

EndPackage;
